commit:     63ef2e4f68dd4b6978641f4fbcd2d04af400d65c
Author:     William Hubbs <williamh <AT> gentoo <DOT> org>
AuthorDate: Mon Feb 10 04:31:31 2020 +0000
Commit:     William Hubbs <williamh <AT> gentoo <DOT> org>
CommitDate: Mon Feb 10 04:31:31 2020 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=63ef2e4f

sys-apps/baselayout: 2.7 bump

Signed-off-by: William Hubbs <williamh <AT> gentoo.org>

 sys-apps/baselayout/Manifest              |   1 +
 sys-apps/baselayout/baselayout-2.7.ebuild | 308 ++++++++++++++++++++++++++++++
 2 files changed, 309 insertions(+)

diff --git a/sys-apps/baselayout/Manifest b/sys-apps/baselayout/Manifest
index b9d9da5be83..293c93ad739 100644
--- a/sys-apps/baselayout/Manifest
+++ b/sys-apps/baselayout/Manifest
@@ -1,2 +1,3 @@
 DIST baselayout-2.4.1.tar.bz2 31307 BLAKE2B 
da26f7fbeefa5efecb6e5d9ded6c2bf3148cd1fcfc6ebb86535f5a9c086c4bb55f6a8420a3c0d0f7008251637f3e4653db875ec427745d039f753008d2f21be2
 SHA512 
e505ad81834aafb574ffee9bc1fce216c1c8c7fa11b0095580f87a37e4b9efb057ee78db7cd5affc64f05d5dd0592c671304414c119b37d86dfaa1e7b84ce7c1
 DIST baselayout-2.6.tar.bz2 31871 BLAKE2B 
4a51d173dc5a2837f78cd1247b5eadd89e7d0b5f2dbc72e75f027b0c23a5db9a386c53e756e80240f36ad4d63e3fe421bf9510c18321d7a31fda140ad47b2860
 SHA512 
5cad5faf56871ae951120643e29db0c39fea6dc845b4755382bd469eca32639ec6cd0cd046d3c439a7cc607b18770036f9c256260d35beaffb094e23cb13740b
+DIST baselayout-2.7.tar.bz2 30317 BLAKE2B 
7b7c284b7d0a9608a0d03dbde0d62d793829b61d5361f5062fdeb8880a2f792c142e20acf7fa92e713e2ebb0bd1609ca65bc8a4191f2bf2c5df4f474eaeef1ee
 SHA512 
8b28d2dc20fd5887db5c0e6b67a4217c4d0730529023fc57fb1ee95a431e1f492fb21e3e66980bef766819e9f542dc7e4ad3ae25465390194bbf970c3653c88e

diff --git a/sys-apps/baselayout/baselayout-2.7.ebuild 
b/sys-apps/baselayout/baselayout-2.7.ebuild
new file mode 100644
index 00000000000..a4b8ca535ac
--- /dev/null
+++ b/sys-apps/baselayout/baselayout-2.7.ebuild
@@ -0,0 +1,308 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit multilib versionator prefix
+
+DESCRIPTION="Filesystem baselayout and init scripts"
+HOMEPAGE="https://wiki.gentoo.org/wiki/No_homepage";
+if [[ ${PV} = 9999 ]]; then
+       EGIT_REPO_URI="https://anongit.gentoo.org/git/proj/${PN}.git";
+       inherit git-r3
+else
+       SRC_URI="https://gitweb.gentoo.org/proj/${PN}.git/snapshot/${P}.tar.bz2";
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sh ~sparc ~x86"
+fi
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="build kernel_FreeBSD kernel_linux +split-usr"
+
+pkg_setup() {
+       multilib_layout
+}
+
+# Create our multilib dirs - the Makefile has no knowledge of this
+multilib_layout() {
+       local dir def_libdir libdir libdirs
+       local prefix prefix_lst
+       def_libdir=$(get_abi_LIBDIR $DEFAULT_ABI)
+       libdirs=$(get_all_libdirs)
+       : ${libdirs:=lib}       # it isn't that we don't trust 
multilib.eclass...
+
+       if [[ -z "${SYMLINK_LIB}" || ${SYMLINK_LIB} = no ]] ; then
+               prefix_lst=( "${EROOT}"{,usr/,usr/local/} )
+               for prefix in ${prefix_lst[@]}; do
+                       for libdir in ${libdirs}; do
+                               dir="${prefix}${libdir}"
+                               if [[ -e "${dir}" ]]; then
+                                       [[ ! -d "${dir}" ]] &&
+                                               die "${dir} exists but is not a 
directory"
+                                       continue
+                               fi
+                               if ! use split-usr && [[ ${prefix} = ${EROOT} 
]]; then
+                                       einfo "symlinking ${dir} to 
usr/${libdir}"
+                                       ln -s usr/${libdir} ${dir} ||
+                                               die " Unable to make ${dir} 
symlink"
+                               else
+                                       einfo "creating directory ${dir}"
+                                       mkdir -p "${dir}" ||
+                                               die "Unable to create ${dir} 
directory"
+                               fi
+                       done
+               done
+               return 0
+       fi
+
+       [ -z "${def_libdir}" ] &&
+               die "your DEFAULT_ABI=$DEFAULT_ABI appears to be invalid"
+
+       # figure out which paths should be symlinks and which should be 
directories
+       local dirs syms exp d
+       for libdir in ${libdirs} ; do
+               if use split-usr ; then
+                       exp=( {,usr/,usr/local/}${libdir} )
+               else
+                       exp=( {usr/,usr/local/}${libdir} )
+               fi
+               for d in "${exp[@]}" ; do
+                       # most things should be dirs
+                       if [ "${SYMLINK_LIB}" = "yes" ] && [ "${libdir}" = 
"lib" ] ; then
+                               [ ! -h "${d}" ] && [ -e "${d}" ] && dirs+=" 
${d}"
+                       else
+                               [ -h "${d}" ] && syms+=" ${d}"
+                       fi
+               done
+       done
+       if [ -n "${syms}${dirs}" ] ; then
+               ewarn "Your system profile has SYMLINK_LIB=${SYMLINK_LIB:-no}, 
so that means you need to"
+               ewarn "have these paths configured as follows:"
+               [ -n "${dirs}" ] && ewarn "symlinks to '${def_libdir}':${dirs}"
+               [ -n "${syms}" ] && ewarn "directories:${syms}"
+               ewarn "The ebuild will attempt to fix these, but only for 
trivial conversions."
+               ewarn "If things fail, you will need to manually create/move 
the directories."
+               echo
+       fi
+
+       # setup symlinks and dirs where we expect them to be; do not migrate
+       # data ... just fall over in that case.
+       if use split-usr ; then
+               prefix_lst=( "${EROOT}"{,usr/,usr/local/} )
+       else
+               prefix_lst=( "${EROOT}"{usr/,usr/local/} )
+       fi
+       for prefix in "${prefix_lst[@]}"; do
+               if [ "${SYMLINK_LIB}" = yes ] ; then
+                       # we need to make sure "lib" points to the native libdir
+                       if [ -h "${prefix}lib" ] ; then
+                               # it's already a symlink!  assume it's pointing 
to right place ...
+                               continue
+                       elif [ -d "${prefix}lib" ] ; then
+                               # "lib" is a dir, so need to convert to a 
symlink
+                               ewarn "Converting ${prefix}lib from a dir to a 
symlink"
+                               rm -f "${prefix}lib"/.keep
+                               if rmdir "${prefix}lib" 2>/dev/null ; then
+                                       ln -s ${def_libdir} "${prefix}lib" || 
die
+                               else
+                                       die "non-empty dir found where we 
needed a symlink: ${prefix}lib"
+                               fi
+                       else
+                               # nothing exists, so just set it up sanely
+                               ewarn "Initializing ${prefix}lib as a symlink"
+                               mkdir -p "${prefix}" || die
+                               rm -f "${prefix}lib" || die
+                               ln -s ${def_libdir} "${prefix}lib" || die
+                               mkdir -p "${prefix}${def_libdir}" #423571
+                       fi
+               else
+                       # we need to make sure "lib" is a dir
+                       if [ -h "${prefix}lib" ] ; then
+                               # "lib" is a symlink, so need to convert to a 
dir
+                               ewarn "Converting ${prefix}lib from a symlink 
to a dir"
+                               rm -f "${prefix}lib" || die
+                               if [ -d "${prefix}lib32" ] ; then
+                                       ewarn "Migrating ${prefix}lib32 to 
${prefix}lib"
+                                       mv "${prefix}lib32" "${prefix}lib" || 
die
+                               else
+                                       mkdir -p "${prefix}lib" || die
+                               fi
+                       elif [ -d "${prefix}lib" ] && ! has lib32 ${libdirs} ; 
then
+                               # make sure the old "lib" ABI location does not 
exist; we
+                               # only symlinked the lib dir on systems where 
we moved it
+                               # to "lib32" ...
+                               case ${CHOST} in
+                               *-gentoo-freebsd*) ;; # We want it the other 
way on fbsd.
+                               i?86*|x86_64*|powerpc*|sparc*|s390*)
+                                       if [[ -d ${prefix}lib32 && ! -h 
${prefix}lib32 ]] ; then
+                                               rm -f "${prefix}lib32"/.keep
+                                               if ! rmdir "${prefix}lib32" 
2>/dev/null ; then
+                                                       ewarn "You need to 
merge ${prefix}lib32 into ${prefix}lib"
+                                                       die "non-empty dir 
found where there should be none: ${prefix}lib32"
+                                               fi
+                                       fi
+                                       ;;
+                               esac
+                       else
+                               # nothing exists, so just set it up sanely
+                               ewarn "Initializing ${prefix}lib as a dir"
+                               mkdir -p "${prefix}lib" || die
+                       fi
+               fi
+       done
+       if ! use split-usr ; then
+               for libdir in ${libdirs}; do
+                       if [[ ! -e "${EROOT}${libdir}" ]]; then
+                               ln -s usr/"${libdir}" "${EROOT}${libdir}"
+                       fi
+               done
+       fi
+}
+
+pkg_preinst() {
+       # This is written in src_install (so it's in CONTENTS), but punt all
+       # pending updates to avoid user having to do etc-update (and make the
+       # pkg_postinst logic simpler).
+       rm -f "${EROOT}"/etc/._cfg????_gentoo-release
+
+       # We need to install directories and maybe some dev nodes when building
+       # stages, but they cannot be in CONTENTS.
+       # Also, we cannot reference $S as binpkg will break so we do this.
+       multilib_layout
+       if use build ; then
+               if use split-usr ; then
+                       emake -C "${ED}/usr/share/${PN}" DESTDIR="${EROOT}" 
layout
+               else
+                       emake -C "${ED}/usr/share/${PN}" DESTDIR="${EROOT}" 
layout-usrmerge
+               fi
+       fi
+       rm -f "${ED}"/usr/share/${PN}/Makefile
+}
+
+src_prepare() {
+       default
+       if use prefix; then
+               hprefixify -e "/EUID/s,0,${EUID}," -q '"' etc/profile
+               hprefixify etc/{env.d/50baselayout,shells} share.Linux/passwd
+               echo PATH=/usr/bin:/bin >> etc/env.d/99host
+               echo ROOTPATH=/usr/sbin:/sbin:/usr/bin:/bin >> etc/env.d/99host
+       fi
+
+       # don't want symlinked directories in PATH on systems with usr-merge
+       if ! use split-usr; then
+               sed \
+                       -e 's|/usr/local/sbin:||g' \
+                       -e 's|:/usr/sbin:|:|g' \
+                       -e 's|:/sbin:|:|g' \
+                       -e 's|:/bin:|:|g' \
+                       -i etc/env.d/50baselayout || die
+       fi
+
+       # handle multilib paths.  do it here because we want this behavior
+       # regardless of the C library that you're using.  we do explicitly
+       # list paths which the native ldconfig searches, but this isn't
+       # problematic as it doesn't change the resulting ld.so.cache or
+       # take longer to generate.  similarly, listing both the native
+       # path and the symlinked path doesn't change the resulting cache.
+       local libdir ldpaths
+       for libdir in $(get_all_libdirs) ; do
+               use split-usr && ldpaths+=":${EPREFIX}/${libdir}"
+               ldpaths+=":${EPREFIX}/usr/${libdir}"
+               ldpaths+=":${EPREFIX}/usr/local/${libdir}"
+       done
+       echo "LDPATH='${ldpaths#:}'" >> etc/env.d/50baselayout
+
+       # rc-scripts version for testing of features that *should* be present
+       echo "Gentoo Base System release ${PV}" > etc/gentoo-release
+}
+
+src_install() {
+       emake \
+               OS=$(usex kernel_FreeBSD BSD Linux) \
+               DESTDIR="${ED}" \
+               install
+       dodoc ChangeLog
+
+       # need the makefile in pkg_preinst
+       insinto /usr/share/${PN}
+       doins Makefile
+}
+
+pkg_postinst() {
+       local x
+
+       # We installed some files to /usr/share/baselayout instead of /etc to 
stop
+       # (1) overwriting the user's settings
+       # (2) screwing things up when attempting to merge files
+       # (3) accidentally packaging up personal files with quickpkg
+       # If they don't exist then we install them
+       for x in master.passwd passwd shadow group fstab ; do
+               [ -e "${EROOT}etc/${x}" ] && continue
+               [ -e "${EROOT}usr/share/baselayout/${x}" ] || continue
+               cp -p "${EROOT}usr/share/baselayout/${x}" "${EROOT}"etc
+       done
+
+       # Force shadow permissions to not be world-readable #260993
+       for x in shadow ; do
+               [ -e "${EROOT}etc/${x}" ] && chmod o-rwx "${EROOT}etc/${x}"
+       done
+
+       # Take care of the etc-update for the user
+       if [ -e "${EROOT}"etc/._cfg0000_gentoo-release ] ; then
+               mv "${EROOT}"etc/._cfg0000_gentoo-release 
"${EROOT}"etc/gentoo-release
+       fi
+
+       # whine about users that lack passwords #193541
+       if [[ -e "${EROOT}"etc/shadow ]] ; then
+               local bad_users=$(sed -n '/^[^:]*::/s|^\([^:]*\)::.*|\1|p' 
"${EROOT}"/etc/shadow)
+               if [[ -n ${bad_users} ]] ; then
+                       echo
+                       ewarn "The following users lack passwords!"
+                       ewarn ${bad_users}
+               fi
+       fi
+
+       # whine about users with invalid shells #215698
+       if [[ -e "${EROOT}"etc/passwd ]] ; then
+               local bad_shells=$(awk -F: 'system("test -e " $7) { print $1 " 
- " $7}' "${EROOT}"etc/passwd | sort)
+               if [[ -n ${bad_shells} ]] ; then
+                       echo
+                       ewarn "The following users have non-existent shells!"
+                       ewarn "${bad_shells}"
+               fi
+       fi
+
+       # https://bugs.gentoo.org/361349
+       if use kernel_linux; then
+               mkdir -p "${EROOT}"run
+
+               local found fstype mountpoint
+               while read -r _ mountpoint fstype _; do
+               [[ ${mountpoint} = /run ]] && [[ ${fstype} = tmpfs ]] && found=1
+               done < "${ROOT}"proc/mounts
+               [[ -z ${found} ]] &&
+                       ewarn "You should reboot now to get /run mounted with 
tmpfs!"
+       fi
+
+       for x in ${REPLACING_VERSIONS}; do
+               if ! version_is_at_least 2.4 ${x}; then
+                       ewarn "After updating ${EROOT}etc/profile, please run"
+                       ewarn "env-update && . /etc/profile"
+               fi
+
+               if ! version_is_at_least 2.6 ${x}; then
+                       ewarn "Please run env-update then log out and back in 
to"
+                       ewarn "update your path."
+               fi
+               # clean up after 2.5 typos
+               # https://bugs.gentoo.org/show_bug.cgi?id=656380
+               if [[ ${x} == 2.5 ]]; then
+                       rm -fr "${EROOT}{,usr"
+               fi
+       done
+
+       if [[ -e "${EROOT}"etc/env.d/00basic ]]; then
+               ewarn "${EROOT}etc/env.d/00basic is now 
${EROOT}etc/env.d/50baselayout"
+               ewarn "Please migrate your changes."
+       fi
+}

Reply via email to